/*
 * 
 * WORKOUT ARCS
 * 
 */
// Custom Arc Attribute, position x&y, value portion of total, total value, Radius
var archtype = Raphael("timeCircle", 220, 220);
archtype.customAttributes.arc = function (xloc, yloc, value, total, R) {
    var alpha = 360 / total * value,
        a = (90 - alpha) * Math.PI / 180,
        x = xloc + R * Math.cos(a),
        y = yloc - R * Math.sin(a),
        path;
    if (total == value) {
        path = [
            ["M", xloc, yloc - R],
            ["A", R, R, 0, 1, 1, xloc - 0.01, yloc - R]
        ];
    } else {
        path = [
            ["M", xloc, yloc - R],
            ["A", R, R, 0, +(alpha > 180), 1, x, y]
        ];
    }
    return {
        path: path
    };
};

// CENTER CIRCLE
var actionTextCircleLight = "#0090ef";
var actionTextCircleDark = "#0071bc";

var actionTextCircle = archtype.circle(110, 110, 76); // (x,y,radius)

actionTextCircle.attr("fill", actionTextCircleLight);
actionTextCircle.attr("stroke", actionTextCircleLight);


// OUTER ARC
var actionArc = archtype.path().attr({
    "stroke": "#8cc63f",
    "stroke-width": 8,
    arc: [110, 110, 100, 100, 100]	// [x,y,value,max,radius]
});

// INNER ARC
var workoutArc = archtype.path().attr({
    "stroke": "#0071bc",
    "stroke-width": 20,
    arc: [110, 110, 100, 100, 86]	// [x,y,value,max,radius]
});

// CENTER CIRCLE TEXT
var actionTextCircleTextLight = "#fff";
var actionTextCircleTextDark = "#f2f1f0";
var actionTextCircleText = archtype.text(110, 60, "WALK").attr({
	"fill":			actionTextCircleTextLight, 
	"font-size":	40
	});




/*
 * 
 * PROGRESS ARC
 * 
 */
var archtype2 = Raphael("progressCircle", 220, 220);
archtype2.customAttributes.arc = function (xloc, yloc, value, total, R) {
    var alpha = 360 / total * value,
        a = (90 - alpha) * Math.PI / 180,
        x = xloc + R * Math.cos(a),
        y = yloc - R * Math.sin(a),
        path;
    if (total == value) {
        path = [
            ["M", xloc, yloc - R],
            ["A", R, R, 0, 1, 1, xloc - 0.01, yloc - R]
        ];
    } else {
        path = [
            ["M", xloc, yloc - R],
            ["A", R, R, 0, +(alpha > 180), 1, x, y]
        ];
    }
    return {
        path: path
    };
};


// OUTER ARC
var progressArc = archtype2.path().attr({
    "stroke": "#8cc63f",
    "stroke-width": 20,
    arc: [110, 110, 0, 27, 100]	// [x,y,value,max,radius]
});

// CENTER CIRCLE TEXT
var progressTextCircleText = archtype2.text(110, 60, "%").attr({
	"fill":			"#8cc63f", 
	"font-size":	40
	});
