
// Setting #container div as a jqm pageContainer
    $.mobile.pageContainer = $('#container');

// Catch backbutton
document.addEventListener("deviceready", onDeviceReady, false);
function onDeviceReady() {
	document.addEventListener("backbutton", backButtonPressed, false );
	document.addEventListener("menubutton", menuButtonPressed, false);
}


// Event Binders
$(document).on("pagebeforeshow",	"#pageSplash",	showPageSplash);
$(document).on("pagebeforeshow",	"#pageIndex",	showPageIndex);
$(document).on("pagebeforeshow",	"#pageSettings",	showPageSettings);
$(document).on("pagebeforeshow",	"#pageProgress",	showPageProgress);
$( "#weekSelectorPrev" ).bind( "touchstart", weekPrev );
$( "#weekSelectorNext" ).bind( "touchstart", weekNext );
$( "#daySelectorPrev" ).bind( "touchstart", dayPrev );
$( "#daySelectorNext" ).bind( "touchstart", dayNext );
$( ".setting" ).bind( "click", saveSettings );
$(document).on("touchstart",	"#buttonResetSettings",	resetSettings);
$(document).on("touchstart",	"#buttonClearProgressYes",	clearProgressYesPressed);


// Event Handlers
function showPageSplash(){
	$("#splashFact").html(getRandomSplashFact());
	$("#splashQuote").html(getRandomSplashQuote());
	
	if(rand(0,1)==0)
		$("#splashFactContainer").hide();
	else
		$("#splashQuoteContainer").hide();
		
	setTimeout(function() {
		$.mobile.changePage( "#pageIndex", { transition: "fade", changeHash: true })
		}, 3500);
}

function showPageIndex(){

	resetPageHeight();
	
	loadRoutine();
	dayChanged();
}

function getRandomSplashFact(){
	return splashFacts[rand(0,splashFacts.length-1)];
}

function getRandomSplashQuote(){
	return splashQuotes[rand(0,splashQuotes.length-1)];
}

function rand(min, max){
	return Math.floor(Math.random() * (max - min + 1)) + min;
}

function weekChanged(){
	var week = $("#select-week").val();
	
	if(workout && week != workout.week){
		$("#select-day").val('day1');
	}
	
	$("#select-day").change();
}

function dayChanged(){
	
	$("#weekSelectorLabel").html("Week "+week);
	$("#daySelectorLabel").html("Day "+day);
	
	var weekString = "week"+week;
	var dayString = "day"+day;
	
	resetWorkout();
	
	// Print out a stringified version of the workout
	$( "#p-daysWorkout" ).hide().html( getWorkoutString(weekString, dayString) ).fadeIn();
	
	if(workout.completed != 0){
		$( "#p-daysWorkout" ).html( $( "#p-daysWorkout" ).html() + "<span class=\"checkbox\">&#10004;</span> <b>Completed on "+workout.completed+"</b><br />&nbsp;" );
		$( "#btnStartWorkout" ).hide();
	}else{
		$( "#btnStartWorkout" ).show();
	}
}

function numProps(obj) {
  var c = 0;
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) ++c;
  }
  return c;
}

function removeLastCharacter(str){
	return str.substring(0, str.length - 1);
}

function weekPrev(){
	if(week-1>0){
		week--;
		day=1;
		dayChanged();
	}
}

function weekNext(){
	if(week+1<=9){
		week++;
		day=1;
		dayChanged();
	}
}

function dayPrev(){
	if(day-1>0){
		day--;
		dayChanged();
	}
}

function dayNext(){
	if(day+1<=3){
		day++;
		dayChanged();
	}
}

function playAction(){
	playVoice(workout.currentActionName.toLowerCase()+workout.currentActionTime);
}

function playDing(){
	if(isChimeAlertEnabled())
		playAudio("ding");
}

function playVoice(url) {
	if(isVoiceAlertEnabled())
		playAudio(url);
}

function playAudio(url) {
    
    // Play the audio file at url
    var my_media = new Media(getPhoneGapPath() + "media/" + url + ".mp3",
        // success callback
        function() {
            mediaIsPlaying = false;
        },
        // error callback
        function(err) {
            alert("playAudio():Audio Error: "+err);
    });

    // Play audio
    mediaIsPlaying = true;
    my_media.play();
}

function getPhoneGapPath() {

    var path = window.location.pathname;
    path = path.substr( path, path.length - 10 );
    return 'file://' + path;

};

function vibrate() {
	if(isVibrateAlertEnabled())
		navigator.notification.vibrate(2000);
}

// Prevents backbutton from working on Android
function onBackKeyDown(e) {
  e.preventDefault();
}

function saveSettings() {
	
	if ( $('#checkboxChimeAlert').is(':checked') )
	{
		window.localStorage.setItem("alertChime", "true");
	}else{
		window.localStorage.setItem("alertChime", "false");
	}
	
	if ( $('#checkboxVoiceAlert').is(':checked') )
	{
		window.localStorage.setItem("alertVoice", "true");
	}else{
		window.localStorage.setItem("alertVoice", "false");
	}
	
	if ( $('#checkboxVibrateAlert').is(':checked') )
	{
		window.localStorage.setItem("alertVibrate", "true");
	}else{
		window.localStorage.setItem("alertVibrate", "false");
	}
	
}

function showPageSettings()
{
	// Check if this is the first time running (i.e. settings have not been set)
	if(window.localStorage.getItem("alertChime") === null){
		resetSettings();
	}
	
	
	if(window.localStorage.getItem("alertChime")=="true")
	{
		$('#checkboxChimeAlert').prop('checked', true).checkboxradio('refresh');
	}else{
		$('#checkboxChimeAlert').prop('checked', false).checkboxradio('refresh');
	}
	
	if(window.localStorage.getItem("alertVoice")=="true")
	{
		$('#checkboxVoiceAlert').prop('checked', true).checkboxradio('refresh');
	}else{
		$('#checkboxVoiceAlert').prop('checked', false).checkboxradio('refresh');
	}
	
	if(window.localStorage.getItem("alertVibrate")=="true")
	{
		$('#checkboxVibrateAlert').prop('checked', true).checkboxradio('refresh');
		
	}else{
		$('#checkboxVibrateAlert').prop('checked', false).checkboxradio('refresh');
	}
}

function showPageProgress()
{
	if(window.localStorage.getItem("routine") !== null){

		var numCompleted = 0;

		for(var week in routine){
			for(var day in routine[week]){
				if(routine[week][day]['completed'] != 0){
					numCompleted++;
				}
			}
		}
		
		// Finally, update the arc to reflect how much is completed
		progressArc.animate({
			arc: [110, 110, numCompleted, 27, 100]
		}, 1000, "easeInOut");
		
		// Update the caption at the bottom
		$("#progressNumCompleted").html(numCompleted);

		var perCompleted = Math.round( (numCompleted/27) * 100);
		progressTextCircleText.attr({text: perCompleted+"%", x:110, y:60});
		$("#progressPerRemaining").html( (100 - perCompleted) + "%" );
	
	}
}

function resetSettings()
{
	window.localStorage.setItem("alertChime", "true");
	$('#checkboxChimeAlert').prop('checked', true).checkboxradio('refresh');
	window.localStorage.setItem("alertVoice", "true");
	$('#checkboxVoiceAlert').prop('checked', true).checkboxradio('refresh');
	window.localStorage.setItem("alertVibrate", "true");
	$('#checkboxVibrateAlert').prop('checked', true).checkboxradio('refresh');
	saveSettings();
}

function isChimeAlertEnabled()
{
	if(window.localStorage.getItem("alertChime")=="true")
		return true;
	else
		return false;
}

function isVoiceAlertEnabled()
{
	if(window.localStorage.getItem("alertVoice")=="true")
		return true;
	else
		return false;
}

function isVibrateAlertEnabled()
{
	if(window.localStorage.getItem("alertVibrate")=="true")
		return true;
	else
		return false;
}

function saveRoutine(){
	window.localStorage.setItem("routine", JSON.stringify(routine) );
}

function loadRoutine(){
	// If the routine has been saved before, load it. Otherwise, we'll keep the default on.
	if(window.localStorage.getItem("routine") !== null)
		routine = JSON.parse( window.localStorage.getItem("routine") );
}

function resetPageHeight(){
	var viewPortHeight = $(window).height();
    var headerHeight = $('div[data-role="header"]').height();
    var footerHeight = $('div[data-role="footer"]').height();
    var contentHeight = viewPortHeight - headerHeight - footerHeight;

    // Set all pages with class="page-content" to be at least contentHeight
    $('.ui-content').css({'min-height': contentHeight -100 + 'px'});
}

function clearProgressYesPressed() {
	$( "#popupClearProgress" ).popup( "close" );
	clearProgress();
}

function clearProgress() {
	routine = routineDefault;
	saveRoutine();
}

function backButtonPressed(e) {

	var activePage = $.mobile.pageContainer.pagecontainer( 'getActivePage' ).attr( 'id' );

	if(activePage=="pageWorkout"){
		e.preventDefault();
		$( "#popupDialog" ).popup( "open" );
	}else if(activePage=="pageIndex"){
		e.preventDefault();
		navigator.app.exitApp();
	}else{
		navigator.app.backHistory();
	}

}

function menuButtonPressed(e) {

	var activePage = $.mobile.pageContainer.pagecontainer( 'getActivePage' ).attr( 'id' );

	if(activePage=="pageIndex"){
		toggleMenu();
	}

}

function toggleMenu(){
	$( "#panelMenu" ).panel( "open" );
}

