

// Event Binders
$(document).on("pagebeforeshow",	"#pageWorkout", 		showPageWorkout);
$(document).on("click",		"#endWorkoutYesButton", endWorkoutYesPressed);
$( "#pauseButton" ).bind( 			"touchstart", 			pauseToggle );
//$( "#timeLeft" ).bind( 				"touchstart", 			timeForward );

// Workout Constructor
function Workout(week, day)
{
	this.week = week;
	this.day = day;
	this.schedule = [];
	this.completed = 0;
	
	var i = 0;
	var dayObj = routine[week][day];
	
	for(var v in dayObj){
		if(i == 0){
			this.completed = dayObj[v];
		}else if(i == 1){
			this.totalTime = dayObj[v];
		}else{
			var arr = new Array();
			arr[0] = v;
			arr[1] = dayObj[v];
			this.schedule[i] = arr;
		}
		i++;
	}
	
	this.totalActions = i-1;
	this.warmupComplete = false;
	
	// Setup the first action
	this.currentActionIndex = 0;
	this.currentActionName;
	this.currentActionTime = 300;
	
	
	this.setAction = function(index){
		var action = this.schedule[index];
		this.currentActionIndex = index;
		this.currentActionName = removeLastCharacter( action[0].toUpperCase() );
		this.currentActionTime = action[1];
	} // setAction
	
	this.loadNextAction = function(){
		this.setAction(this.currentActionIndex+1);
	}
	
	this.setComplete = function(completed){
		this.completed = completed;
		routine[this.week][this.day]['completed'] = this.completed;
	}
	
	// Debugging stringify function
	this.stringify = function(){
		var ret = '';
		ret += "TotalTime: "+this.totalTime+"<br />";
		ret += "TotalActions: "+this.totalActions+"<br />";
		for(var x=0; x<this.schedule.length; x++){
			for(var action in this.schedule[x]){
				ret += "Action: "+removeLastCharacter(action)+" | Time: "+this.schedule[x][action]+"<br />";
			}
		}
		return ret;
	} // stringify
	
} //Workout Constructor

function endWorkoutYesPressed(){
	cancelWorkout();
}

function showPageWorkout(){
	time = 300;
	timer = setInterval(updateTime, 1000);
	playVoice("beginwarmup");
}

function getWorkoutString(week, day){
	var i = 0;
	var ret = "<ul>";
	var dayObj = routine[week][day];
	for(var v in dayObj){
		if(i==0 || i==1){
			i++;
			continue;
		}else if( (week=='week1' || week=='week2') && i==4){
			ret += "<li>Alternate for 20 min</li>";
			break;
		}else{
			ret += "<li>" + removeLastCharacter(v) + " for " + secToMin(dayObj[v]) + " min</li>";
		}
		i++;
	}
	ret += "</ul>"
	return ret;
}

function secToMin(seconds){
	return seconds/60;
}


function updateTime(){
	if(time>0){
		time--;
		$( "#timeLeft" ).html(secToString(time)+"<br />remaining");
		actionArc.animate({
			arc: [110, 110, time, workout.currentActionTime, 100]
		}, 900, "easeInOut");
		
		if(actionTextCircle.attr('fill')==actionTextCircleLight){
			actionTextCircle.animate({ fill: actionTextCircleDark, stroke: actionTextCircleDark }, 900);
			actionTextCircleText.animate({ fill: actionTextCircleTextDark }, 900);
		}else{
			actionTextCircle.animate({ fill: actionTextCircleLight, stroke: actionTextCircleLight }, 900);
			actionTextCircleText.animate({ fill: actionTextCircleTextLight }, 900);
		}
	}else{ // if time < 0
		advanceWorkout();
	} // if
} // updateTime

function secToString(seconds){
	var mins = Math.floor(secToMin(seconds));
	var secs = seconds - (mins*60);
	return mins+" min "+secs+" sec";
}

function pauseToggle(){
	if( $( "#pauseButton" ).html() == "Pause" ){
		clearInterval(timer);
		$( "#pauseButton" ).html("Resume");
	} else {
		timer = setInterval(updateTime, 1000);
		$( "#pauseButton" ).html("Pause");
	}
}

// When a workout gets completed (i.e. not aborted)
function endWorkout(){
	
	time = 0;
	clearInterval(timer);
	timer = null;
	
	actionTextCircleText.attr({text: "☺", x:110, y:110});
	workoutArc.animate({
		arc: [110, 110, 0, 0, 86]
	}, 1000, "easeInOut");
	playDing();
	playVoice("workoutcomplete");
	
	$("#timeLeft").html("Workout Complete");
	
	// Set the workout to complete at this exact time
	navigator.globalization.dateToString( 
	
		new Date(),
		function (date) { workout.setComplete(date.value) },
		function () {alert('Error getting date\n');},
		{formatLength:'short', selector:'date and time'}
		
	);
	
	saveRoutine();
	
	setInterval(resetPageWorkout, 2000);
	
}

// When a workout gets aborted
function cancelWorkout(){
	
	time = 0;
	clearInterval(timer);
	timer = null;
	
	resetWorkout();
	
	playDing();
	
	resetPageWorkout();
	
}

function resetWorkout(){
	
	var weekString = "week"+week;
	var dayString = "day"+day;
	
	workout = new Workout(weekString, dayString);
}

function resetPageWorkout(){
	
	$.mobile.changePage('#pageIndex', { transition: 'slide', reverse: true });
	
	actionArc.animate({
			arc: [110, 110, 0, 0, 100]
		}, 100, "easeInOut");
	$("#workoutState").html("WARMUP");
	workoutArc.animate({
			arc: [110, 110, 0, 0, 86]
		}, 100, "easeInOut");
	actionTextCircleText.attr({text: "WALK", x:110, y:110});

	$("#timeLeft").html("");

	// Make sure the Pause button has the right text
	$( "#pauseButton" ).html("Pause");
}

function timeForward(){
	if(time-30>0)
		time -= 30;
	else
		time = 0;
}

function timeBackward(){
	time += 30;
}

function advanceWorkout(){
	if(workout.currentActionIndex < workout.totalActions){
		workout.loadNextAction();
		
		$("#workoutState").html("WORKOUT");
		actionTextCircleText.attr({text: workout.currentActionName, x:110, y:110});
		
		workoutArc.animate({
			arc: [110, 110, workout.totalActions-(workout.currentActionIndex-1), workout.totalActions, 86]
		}, 1000, "easeInOut");
		
		time = workout.currentActionTime;
		
		playDing();
		if(workout.currentActionIndex==1){
			playVoice("warmupcomplete");
			setTimeout(playAction, 1200);
		}else{
			playAction();
		}
		vibrate();
		
	}else{
		
		endWorkout();
		
	}
}


